'-- t-log13.bas ------------------------------------------------ >>fst'05<< -
' - T-Log   Gafischer TemperaturLOGger   Version 1.3
' - yt-Schreiber
' - X- und Y-Achse vom Anwender skalierbar
' - Messwerte werden als Textdatei gespeichert
' - Messgrafik mit Zusatzprogramm "snapshot" (TSR) speicherbar
' Hardware:
' - LM75 9-Bit Temperatursensor an LPT 1 oder LPT 2
' - EGA- oder CGA-Grafik (damit auch fr DOS-Handheld Computer geeignet)
'   getestet auf Highscreen Handy Organizer
' - luft (hoffentlich) auf allen PC's mit DOS / Win3.x / Win9x
' Software:
' - QBasic / Quick-Basic 4.5 / Basic PDS / Visual-Basic fr DOS
'-- V 20051027 ------------------------------- http://www.FrankSteinberg.de -

DEFINT A-Z

DECLARE FUNCTION LM75! ()
DECLARE FUNCTION XVal! (A$)
DECLARE FUNCTION Datum$ ()
DECLARE FUNCTION Tmr& ()
DECLARE SUB WarteAuf (TT)
DECLARE SUB MessGeraet ()
DECLARE SUB Gitter ()
DECLARE SUB MinMax ()
DECLARE SUB WertInDatei (Einheit$)
DECLARE SUB Zeitmess (T1&)
DECLARE SUB Datenzeile2 (Abbruch)
DECLARE SUB Params (Titel$)
DECLARE SUB Port ()
DECLARE SUB MessWert (Bereich$, Einheit$)
DECLARE SUB Dateikopf (Datei$, Titel$, Bereich$, Einheit$)
DECLARE SUB sek2zeit (Seku&, Zeit$, StuMin$, MinSek$)
DECLARE SUB Datenzeile (Abbruch, Bereich$, Einheit$)
DECLARE SUB Gitter2 ()
DECLARE SUB Zufall ()
DECLARE SUB Linien ()
DECLARE SUB Kopfzeile (Bereich$, Einheit$, Titel$)
DECLARE SUB Beschriftung ()
DECLARE SUB Beschriften2 ()
DECLARE SUB EndBild ()
DECLARE SUB Dateifuss ()
DECLARE SUB EndeHinweis (Einheit$)
DECLARE SUB GrafikUmben (GrDat)
DECLARE SUB SchnellEnde (GrDat)
DECLARE SUB DatenLoesch (GrDat)
DECLARE SUB TitelZeile ()
DECLARE FUNCTION MittelW2% (Mess%())

DIM SHARED MGeraet       'Messgerte - Typ
DIM SHARED DRg           'I/O Basisadresse des verwendeten Parallelports
DIM SHARED Seku&         'aktuelle Laufzeit in Sekunden
DIM SHARED Zeit$         'aktuelle Laufzeit im ForMat Std:Min:Sek
DIM SHARED UhrZeit$      'aktuelle Uhrzeit
DIM SHARED ZBasis$       'Kennzeichen, ob Uhrzeit auf X-Achse
DIM SHARED MessInterv    'MessIntervall in Sekunden
DIM SHARED FlipFlop      'wechselt pro Sek zwischen 0 und -1
DIM SHARED Messp&        'Anzahl MessPunkte in Werte1!
DIM SHARED ASek&         'Aufzeichnungsdauer in Sekunden
DIM SHARED XMax&         'Maximalwert der X-Achse (Zeit) in Sekunden
DIM SHARED YMax!         'Maximalwert der Y-Achse (Messwerte)
DIM SHARED YMin!         'Minimalwert der Y-Achse (Messwerte)
DIM SHARED Wert!         'Messwert
DIM SHARED LetztWert!    'letzter aufgezeichneter Messwert
DIM SHARED MinWert!      'Minimal-Messwert
DIM SHARED MaxWert!      'Maximal-Messwert
DIM SHARED DWert!        'Durchschnittswert
DIM SHARED T1&           'Startzeit (Sek seit Mitternacht)
DIM SHARED MinSek&       'Zeitpunkt vom Minimal-Messwert in Sekunden
DIM SHARED MaxSek&       'Zeitpunkt vom Maximal-Messwert in Sekunden
DIM SHARED MinZeit$      'Zeitpunkt vom Minimal-Messwert
DIM SHARED MaxZeit$      'Zeitpunkt vom Maximal-Messwert
DIM SHARED MinDatum$     'Datum vom Minimal-Messwert
DIM SHARED MaxDatum$     'Datum vom Maximal-Messwert
DIM SHARED Taste$        'Zuletzt gedrckte Taste$
DIM SHARED Datei$        'Name der Messdatendatei
DIM SHARED Abbruch       'Kennziffer fr Benutzereingaben

'----------------------------------------------------------------------------
'*** Variablen vorbelegen
MinZeit$ = "--:--:--"
MaxZeit$ = "--:--:--"
MessInterv = 1
ASek& = 60
YMax! = 4
YMin! = 0
MGeraet = 9

'----------------------------------------------------------------------------
'*** Schnittstelle und Programmparameter abfragen
Parameter:
CLS
CALL Params(Titel$)
MessG:
CALL MessGeraet
IF MGeraet = 99 THEN GOTO Parameter
IF MGeraet <> 9 THEN CALL Port
IF Taste$ = "Z" THEN Taste$ = "": GOTO Parameter
Taste$ = ""

'----------------------------------------------------------------------------
'*** Auf erste Daten warten

'Spannungsversorgung an DATA7 ein:
OUT DRg, 128

CLS
LOCATE 12, 12
PRINT "***  Warte auf Daten;    zurck = [z]     Ende = [e]    ***"

DO
 CALL MessWert(Bereich$, Einheit$)
 IF Taste$ = "Z" THEN Taste$ = "": GOTO MessG
 IF Taste$ = CHR$(27) OR Taste$ = "E" THEN CALL SchnellEnde(GrDat)
LOOP UNTIL LEN(Einheit$) > 0

'----------------------------------------------------------------------------
'*** Grafik-Bildschirm aufbauen mit Starthinweis
ON ERROR GOTO CGA               'automatische Prfung, ob EGA 640x350 mglich
 SCREEN 9
 Grafik = 350
 VIEW (39, 14)-(639, 307), 10
GOTO EndeGrafik
CGA:                            'bei Fehler CGA-Modus
 SCREEN 2
 VIEW (39, 8)-(639, 174), 1
 RESUME EndeGrafik
EndeGrafik:

WINDOW (0, YMin!)-(ASek&, YMax!)
CALL Kopfzeile(Bereich$, Einheit$, Titel$)
CALL Beschriftung
CALL Gitter
LOCATE 11, 26
PRINT "   Aufzeichnung starten = [Enter]   "
LOCATE 12, 26
PRINT "   zurck = [z]        Ende = [e]   "
Taste$ = ""
DO
 CALL WarteAuf(0)
 CALL MessWert(Bereich$, Einheit$)
 CALL Datenzeile(Abbruch, Bereich$, Einheit$)
 IF Taste$ = CHR$(27) OR Taste$ = "E" THEN CALL SchnellEnde(GrDat)
 IF Taste$ = CHR$(13) THEN EXIT DO
 IF Taste$ = "Z" THEN SCREEN 0: GOTO MessG
 CALL WarteAuf(9)
LOOP

'----------------------------------------------------------------------------
' *** Starthinweis lschen und Aufzeichnung starten
SOUND 4000, 1
CLS
IF Grafik = 350 THEN VIEW (39, 14)-(639, 307), 10 ELSE VIEW (39, 8)-(639, 174), 1
CALL Gitter
WINDOW (0, YMin!)-(ASek&, YMax!)
CALL Dateikopf(Datei$, Titel$, Bereich$, Einheit$)

T1& = Tmr&      'Startzeit speichern
IF ZBasis$ = "U" THEN CALL Beschriften2

'============================================================================
' *** Hauptschleife
'============================================================================

DO

Daten:

 Taste$ = ""

 IF SekuAlt& < Seku& THEN
  FlipFlop = -1 - FlipFlop
  CALL MessWert(Bereich$, Einheit$)
  IF Seku& MOD 21600 = 0 THEN                 'Datei alle 6 Std (21600 Sek)
   CLOSE #2                                   'auf Disk speichern
   OPEN Datei$ FOR APPEND AS #2
  END IF
 END IF
 SekuAlt& = Seku&

 CALL Zeitmess(T1&)                           'Laufzeit (Seku&) messen
 CALL sek2zeit(Seku&, Zeit$, x$, Y$)          'Zeit-String erzeugen

 CALL Datenzeile(Abbruch, Bereich$, Einheit$) 'Datenzeilen schreiben

 '*** Wenn Zeit fr neue Messung erreicht oder erste Messung
 IF Seku& >= Messp& * MessInterv THEN
  CALL MinMax                                 'Min/Max-Werte speichern
  CALL WertInDatei(Einheit$)                  'Aktuellen Wert in Datei
  CALL Linien                                 'Linie ins Diagramm zeichnen
  LetzteM& = Seku&                            'Zeit letzter Messpunkt speichern
  Messp& = Messp& + 1                         'Messpunkt zhlen
  LetztWert! = Wert!                          'Alten Messwert speichern
 END IF

 IF Seku& = ASek& THEN GOTO Ende              'Messzeit verstrichen
 IF Taste$ = "" THEN Taste$ = UCASE$(INKEY$)
 IF Taste$ = CHR$(27) OR Taste$ = "E" THEN Abbruch = 1: SOUND 4000, 1
 IF Abbruch = 1 THEN CALL Datenzeile2(Abbruch)'Abfrage einblenden
 IF Abbruch = 2 THEN GOTO Ende                'Abfrage = Ja -> beenden

LOOP

'============================================================================
'*** Abschluss des Programms
'============================================================================

Ende:

OUT DRg, 0                 'Spannungsversorgung aus

CALL Dateifuss             'Min/Maxwert in Datei schreiben

CALL EndeHinweis(Einheit$) 'blinkenden Ende-Hinweis schreiben; Anwender hat
                           'die Mglichkeit, die Grafik zu speichern.
CALL GrafikUmben(GrDat)    'mit snapshot.exe erstellte Grafikdatei umbenennen

CALL SchnellEnde(GrDat)

SUB Beschriften2

 Tmp& = T1&
 LOCATE 23, 3: GOSUB Anzeigen: PRINT " Uhr";

 Tmp& = T1& + ASek& * 1 / 6
 LOCATE 23, 16: GOSUB Anzeigen
 Tmp& = T1& + ASek& * 2 / 6
 LOCATE 23, 28: GOSUB Anzeigen
 Tmp& = T1& + ASek& * 3 / 6
 LOCATE 23, 41: GOSUB Anzeigen
 Tmp& = T1& + ASek& * 4 / 6
 LOCATE 23, 53: GOSUB Anzeigen
 Tmp& = T1& + ASek& * 5 / 6
 LOCATE 23, 65: GOSUB Anzeigen
 Tmp& = T1& + ASek& * 6 / 6
 LOCATE 23, 76: GOSUB Anzeigen

EXIT SUB

Anzeigen:
 DO WHILE Tmp& > 86400
  Tmp& = Tmp& - 86400
 LOOP
 CALL sek2zeit(Tmp&, Zeit$, StuMin$, MinSek$)
 PRINT StuMin$;
RETURN

END SUB

SUB Beschriftung

'Beschriftung der Y-Achse

SELECT CASE YMax!     'Platzbedarf des Maximalwerts ermitteln
CASE 1 TO 9.999999
 Stellen = 1
CASE 10 TO 99.99999
 Stellen = 2
CASE ELSE
 Stellen = 3
END SELECT

SELECT CASE YMin!     'fr das Minuszeichen muss eine Stelle geopfert werden
CASE -9.999999 TO -.0000001
 MStellen = 2
CASE -99.99999 TO -10
 MStellen = 3
CASE -999.9999 TO -100
 MStellen = 4
END SELECT

'Den Wert, mit dem grten Platzbedarf ermitteln
IF MStellen > Stellen THEN Stellen = MStellen
'... und danach die PRINT USING Maske bestimmen

SELECT CASE Stellen
CASE 1
 Maske$ = "#.# "
CASE 2
 Maske$ = "##.#"
CASE 3
 Maske$ = "###.#"
CASE ELSE
 Maske$ = "####"
END SELECT

Zeile = 22
FOR i = 0 TO 10
 LOCATE Zeile, 1
 Zeile = Zeile - 2
 YWert! = (YMax! - YMin!) / 10 * i + YMin!
 PRINT USING Maske$; YWert!
NEXT i

'Beschriftung der X-Achse
 LOCATE 23, 3
 IF ASek& <= 600 THEN PRINT "Min:Sek";  ELSE PRINT "Std:Min";

 Tmp& = ASek& * 1 / 6: LOCATE 23, 16: GOSUB ZeitAnz
 Tmp& = ASek& * 2 / 6: LOCATE 23, 28: GOSUB ZeitAnz
 Tmp& = ASek& * 3 / 6: LOCATE 23, 41: GOSUB ZeitAnz
 Tmp& = ASek& * 4 / 6: LOCATE 23, 53: GOSUB ZeitAnz
 Tmp& = ASek& * 5 / 6: LOCATE 23, 65: GOSUB ZeitAnz
 Tmp& = ASek& * 6 / 6: LOCATE 23, 76: GOSUB ZeitAnz

EXIT SUB

ZeitAnz:
 CALL sek2zeit(Tmp&, Zeit$, StuMin$, MinSek$)
 IF ASek& <= 600 THEN PRINT MinSek$ ELSE PRINT StuMin$
RETURN

WertAnz:

END SUB

SUB Dateifuss
' Min-/Max-Werte in Datendatei schreiben

PRINT #2,
PRINT #2, "; Minimalwert "; STR$(MinWert!); " bei ";
IF ZBasis$ = "U" THEN PRINT #2, MinDatum$ + "  " + MinZeit$ ELSE PRINT #2, MinSek&; "Sekunden"
PRINT #2, "; Maximalwert "; STR$(MaxWert!); " bei ";
IF ZBasis$ = "U" THEN PRINT #2, MaxDatum$ + "  " + MaxZeit$ ELSE PRINT #2, MaxSek&; "Sekunden"
PRINT #2, "; Mittelwert  "; STR$(DWert!);

END SUB

DEFSNG A-Z
SUB Dateikopf (Datei$, Titel$, Bereich$, Einheit$)

'Dateiname erzeugen aus Monat, Tag, Stunde, Minute + ".txt"
Datei$ = LEFT$(DATE$, 2) + MID$(DATE$, 4, 2) + LEFT$(TIME$, 2) + MID$(TIME$, 4, 2) + ".txt"

OPEN Datei$ FOR OUTPUT AS #2 LEN = 8192

PRINT #2, "; Messdaten-Datei des Programms T-Log 1.3 ; angelegt " + Datum$ + ", " + TIME$ + " Uhr"
PRINT #2,
PRINT #2, "; "; Titel$
PRINT #2,
IF ZBasis$ = "U" THEN PRINT #2, ";Zeit" + CHR$(9);  ELSE PRINT #2, ";Sek.";
PRINT #2, CHR$(9); Bereich$; "("; Einheit$; ")"
PRINT #2,

END SUB

DEFINT A-Z
SUB DatenLoesch (GrDat)

SCREEN 0
PRINT

IF Datei$ = "" THEN EXIT SUB

CLOSE #2

IF GrDat <> 1 THEN PRINT " Datendatei >>"; Datei$; "<< lschen ?   "
IF GrDat THEN PRINT " Datendatei >>"; Datei$; "<< und Grafikdatei >>"; LEFT$(Datei$, 8); ".exe<< lschen ?"
PRINT
PRINT " [J]a / [N]ein"

DO
 Taste$ = INPUT$(1)
LOOP UNTIL UCASE$(Taste$) = "J" OR UCASE$(Taste$) = "N"

IF UCASE$(Taste$) = "J" THEN
 PRINT
 PRINT " Lsche: "; Datei$
 KILL Datei$
 IF GrDat THEN PRINT " Lsche: "; LEFT$(Datei$, 8); ".exe"
 IF GrDat THEN KILL LEFT$(Datei$, 8) + ".exe"
 SLEEP 1
END IF

END SUB

SUB Datenzeile (Abbruch, Bereich$, Einheit$)
LOCATE 24, 1
 'PRINT "Aktuell " + Bereich$;
 PRINT USING "Temp aktuell####.#  "; Wert!;
 PRINT Einheit$;
 IF FlipFlop THEN
   PRINT USING "  Max####.#  "; MaxWert!;
   PRINT Einheit$ + " bei " + MaxZeit$;
  ELSE
   PRINT USING "  Min####.#  "; MinWert!;
   PRINT Einheit$ + " bei " + MinZeit$;
 END IF
 IF ZBasis$ = "U" THEN
   PRINT "  "; Datum$; "  "; TIME$; " Uhr";
  ELSE
   PRINT "  Laufz "; Zeit$; " "; LEFT$(TIME$, 5); " Uhr";
 END IF

LOCATE 25, 1
 PRINT USING "Letzte Aufz ####.#  "; LetztWert!;
 PRINT Einheit$;
 PRINT USING "  Mit####.###"; DWert!;
 PRINT Einheit$ + " (Mittelwert)";
 IF Abbruch < 1 THEN PRINT USING "  Aufz####### in###### Sek"; Messp&; Messp& * MessInterv - Seku&;

END SUB

SUB Datenzeile2 (Abbruch)

LOCATE 25, 56
IF FlipFlop THEN
  PRINT " BEENDEN ?  [J]a / [N]ein";
 ELSE
  PRINT "                         ";
END IF

IF UCASE$(Taste$) = "N" THEN Abbruch = 0: SOUND 4000, 1 'Abfrage nicht mehr einblenden
IF UCASE$(Taste$) = "J" THEN Abbruch = 2   'Aufzeichnung endgltig beenden

END SUB

FUNCTION Datum$

'Deutsches Datumsformat mit vierstelliger Jahreszahl erzeugen
Datum$ = MID$(DATE$, 4, 2) + "-" + LEFT$(DATE$, 2) + "-" + RIGHT$(DATE$, 4)

END FUNCTION

SUB EndBild
CLS
PRINT
COLOR 0, 7
PRINT " T-Log 1.3   beendet       "; Datum$; ",  "; TIME$; " Uhr                  >>fst'05<<";
PRINT " INTERNET:        http://www.FrankSteinberg.de                                  ";
COLOR 7, 0
PRINT
PRINT
SYSTEM

END SUB

SUB EndeHinweis (Einheit$)
' blinkenden Ende-Hinweis erzeugen

SOUND 4000, 1

LOCATE 24, 27
 PRINT USING "Max####.###"; MaxWert!;
 PRINT Einheit$ + " bei " + MaxZeit$;

LOCATE 25, 1
 PRINT USING "Mittelwert  ####.###"; DWert!;
 PRINT Einheit$;
 PRINT USING "  Min####.###"; MinWert!;
 PRINT Einheit$ + " bei " + MinZeit$;

DO WHILE Taste$ <> CHR$(27) AND Taste$ <> "E"
 LOCATE 25, 56
 PRINT " Tabelle sichern: [Druck]";
 SLEEP 1
 LOCATE 25, 56
 PRINT " Programm beenden:  [e]  ";
 SLEEP 1
 Taste$ = UCASE$(INKEY$)
LOOP

SOUND 4000, 1

END SUB

SUB Gitter

WINDOW (0, 0)-(12, 10)

'senkrechte Gitterlinien zeichnen
FOR x = 1 TO 11
  LINE (x, 0)-(x, 10), 0, , &H8888
NEXT x

'wagerechte Gitterlinien zeichnen
FOR Y = 1 TO 9
  LINE (0, Y)-(12, Y), 0, , &H101
NEXT Y

END SUB

SUB GrafikUmben (GrDat)
' Wenn Grafikdatei erzeugt wurde; wie Datendatei benennen

OPEN "bild0.exe" FOR BINARY AS #3
IF LOF(3) THEN
  CLOSE #3
  NAME "bild0.exe" AS LEFT$(Datei$, 8) + ".exe"
  GrDat = 1
 ELSE
  CLOSE #3
  KILL "bild0.exe"
END IF

END SUB

SUB Kopfzeile (Bereich$, Einheit$, Titel$)

EinheitY1$ = LEFT$(Bereich$, 2) + "(" + RIGHT$(Einheit$, 2) + ")"

IF LEN(Titel$) < 60 THEN
 Tmp = (68 - LEN(Titel$)) \ 2
 Fuellz$ = SPACE$(Tmp)
END IF

LOCATE 1, 1
PRINT EinheitY1$
LOCATE 1, 10
PRINT Fuellz$ + Titel$;

END SUB

SUB Linien

'Linie zum neuen Messpunkt zeichnen
IF Messp& = 0 THEN
 PSET (0, Wert!), 0
ELSE
 LINE -(Seku&, Wert!), 0
END IF


END SUB

SUB MessGeraet

CALL TitelZeile   'Titelzeile schreiben


MGeraet = 1       'z.Z. nur ein Gert, keine Auswahl erforderlich
EXIT SUB

' ____________________________________________________________________________
' *** Bildschirm fr die Messgerte - Auswahl schreiben

LOCATE 5, 1
PRINT " Bitte Messgert - Typ whlen :"
PRINT " ------------------------------"
PRINT " LM75 9-bit Temperatursensor                                      ->  Taste [1]"
PRINT " Simulationsmodus mit Zufallszahlen; kein Messgert erforderlich  ->  [ Enter ]"
PRINT
PRINT " * =  nicht mit allen Rechnern mglich"

DO
 Taste$ = UCASE$(INPUT$(1))
 IF Taste$ = CHR$(27) OR Taste$ = "E" THEN CALL EndBild
 IF Taste$ = CHR$(13) THEN Taste$ = "9"
 IF Taste$ = "Z" THEN Taste$ = "99"
 MGeraet = VAL(Taste$)
LOOP UNTIL MGeraet > 0 AND MGeraet < 4 OR MGeraet = 9 OR MGeraet = 99

PRINT "                                                         gewhlt  =>        "; MGeraet
PRINT
PRINT
PRINT

END SUB

SUB MessWert (Bereich$, Einheit$)
'Messwert vom LM75 lesen

URg = DRg + 1     'Status-Register an Offset 1
SRg = DRg + 2     'Steuer-Register an Offset 2
DIn = 64          'Bytewert fuer SDA -> ACKNOWLEDGE high
ChDh = 0          'Bytewert fuer STROBE -> SCL high / AUTO FEED -> SDA high
ClDh = 1          'Bytewert fuer STROBE -> SCL low  / AUTO FEED -> SDA high
ChDl = 2          'Bytewert fuer STROBE -> SCL high / AUTO FEED -> SDA low
ClDl = 3          'Bytewert fuer STROBE -> SCL low  / AUTO FEED -> SDA low
DIM Mess(1 TO 7)  'Platz fuer 7 Messungen

'Spannungsversorgung an DATA7 ein:
OUT DRg, 128

DEF SEG = 0

'7 Messwerte speichern:
FOR i = 1 TO 7

 'Grundstellung (i2c-Stop):
 OUT SRg, ChDl  'SCL high
 OUT SRg, ChDh  'SDA high

 'Zwei Timerspruenge warten (55-110 ms):
 T1 = PEEK(&H46C): DO: LOOP WHILE T1 = PEEK(&H46C)
 T1 = PEEK(&H46C): DO: LOOP WHILE T1 = PEEK(&H46C)

 'Start:
 OUT SRg, ChDl   'SDA low
 OUT SRg, ClDl   'SCL low

 'Adressbyte senden:
 OUT SRg, ClDh   'SCL low, Bit7 = 1; Bit7/Bit6/Bit5/Bit4:
 OUT SRg, ChDh   'SCL high           feste Adresse des LM75 = 1001
  OUT SRg, ClDl  'SCL low, Bit6 = 0
  OUT SRg, ChDl  'SCL high
 OUT SRg, ClDl   'SCL low, Bit5 = 0
 OUT SRg, ChDl   'SCL high
  OUT SRg, ClDh  'SCL low, Bit4 = 1
  OUT SRg, ChDh  'SCL high
 OUT SRg, ClDl   'SCL low, Bit3 = 0; Bit1/Bit2/Bit3: variable Adresse des LM75,
 OUT SRg, ChDl   'SCL high           wie A0/A1/A2 verbunden; hier = 000
  OUT SRg, ClDl  'SCL low, Bit2 = 0
  OUT SRg, ChDl  'SCL high
 OUT SRg, ClDl   'SCL low, Bit1 = 0
 OUT SRg, ChDl   'SCL high
  OUT SRg, ClDh  'SCL low, Bit0 = 1  'Bit0: 0=Master(PC) schreibt anschliessend
  OUT SRg, ChDh  'SCL high                  1=Master(PC)  liest   anschliessend

 'LM75 sendet Acknowledge (hier nicht ausgewertet):
 OUT SRg, ClDl   'SCL low, SDA low
 OUT SRg, ChDl   'SCL high
 OUT SRg, ClDl   'SCL low

 'Datenbyte 1 lesen:
 OUT SRg, ChDh   'SCL high, SDA high
 IF (INP(URg) AND DIn) THEN Mess(i) = Mess(i) + 256
 OUT SRg, ClDh   'SCL low
  OUT SRg, ChDh  'SCL high
  IF (INP(URg) AND DIn) THEN Mess(i) = Mess(i) + 128
  OUT SRg, ClDh  'SCL low
 OUT SRg, ChDh   'SCL high
 IF (INP(URg) AND DIn) THEN Mess(i) = Mess(i) + 64
 OUT SRg, ClDh   'SCL low
  OUT SRg, ChDh  'SCL high
  IF (INP(URg) AND DIn) THEN Mess(i) = Mess(i) + 32
  OUT SRg, ClDh  'SCL low
 OUT SRg, ChDh   'SCL high
 IF (INP(URg) AND DIn) THEN Mess(i) = Mess(i) + 16
 OUT SRg, ClDh   'SCL low
  OUT SRg, ChDh  'SCL high
  IF (INP(URg) AND DIn) THEN Mess(i) = Mess(i) + 8
  OUT SRg, ClDh  'SCL low
 OUT SRg, ChDh   'SCL high
 IF (INP(URg) AND DIn) THEN Mess(i) = Mess(i) + 4
 OUT SRg, ClDh   'SCL low
  OUT SRg, ChDh  'SCL high
  IF (INP(URg) AND DIn) THEN Mess(i) = Mess(i) + 2
  OUT SRg, ClDh  'SCL low

 'Acknowledge vom Master senden:
 OUT SRg, ClDl   'SDA low
 OUT SRg, ChDl   'SCL high
 OUT SRg, ClDl   'SCL low

 'Hoechstwertiges Bit vom 2. Datenbyte lesen:
 OUT SRg, ChDh   'SCL high, SDA high
 IF (INP(URg) AND DIn) THEN Mess(i) = Mess(i) + 1
 OUT SRg, ClDh   'SCL low

 'Restliche 7 Takte erzeugen:
 FOR j = 1 TO 7
  OUT SRg, ChDh  'SCL high
  dummy = INP(URg)
  OUT SRg, ClDh  'SCL low
 NEXT j

 'No Acknowledge vom Master senden:
 OUT SRg, ClDh   'SDA high
 OUT SRg, ChDh   'SCL high
 OUT SRg, ClDh   'SCL low

NEXT i                           'naechsten der 7 Messwerte holen


'Mittelwert bilden, zwei Ausreisser loeschen (FUNCTION MittelW2):
'Mess(6) = 0
'Mess(7) = 0
Messung = MittelW2(Mess())

'Temperaturwert in C erzeugen
IF (Messung AND 256) THEN        'Vorzeichen-Bit (Byte1,Bit7) auswerten
  Messung = Messung - 512        'Temperatur unter Null
END IF
Wert! = Messung / 2              'aus 9Bit-Wert wird 8Bit-Wert +/- 0,5

Bereich$ = " T "
Einheit$ = " C"

Taste$ = UCASE$(INKEY$)

END SUB

SUB MinMax

'Minimal- und Maximalwerte speichern

IF Messp& = 0 THEN
 MinWert! = Wert!
 MaxWert! = Wert!
 MaxSek& = Seku&
 MinSek& = Seku&
 IF ZBasis$ = "U" THEN
  MinZeit$ = UhrZeit$
  MaxZeit$ = UhrZeit$
  MinDatum$ = Datum$
  MaxDatum$ = Datum$
 ELSE
  MinZeit$ = Zeit$
  MaxZeit$ = Zeit$
 END IF
END IF

IF Wert! < MinWert! THEN
 MinWert! = Wert!
 IF ZBasis$ = "U" THEN
  MinZeit$ = UhrZeit$
  MinDatum$ = Datum$
 ELSE MinZeit$ = Zeit$
 END IF
 MinSek& = Seku&
END IF

IF Wert! > MaxWert! THEN
 MaxWert! = Wert!
 IF ZBasis$ = "U" THEN
  MaxZeit$ = UhrZeit$
  MaxDatum$ = Datum$
 ELSE MaxZeit$ = Zeit$
 END IF
 MaxSek& = Seku&
END IF

'Mittelwert errechnen
STATIC DSumme!
DSumme! = DSumme! + Wert!
DWert! = DSumme! / (Messp& + 1)

END SUB

FUNCTION MittelW2 (Mess())
'Loescht die beiden am meisten vom Mittelwert abweichenden Messwerte
'und bildet aus den restlichen 5 einen Mittelwert.


DIM Abw(1 TO 7)                   'Platz fuer Abweichungen vom Mittelwert


FOR i = 1 TO 7
 Summe = Summe + Mess(i)          'Mittelwert berechnen
NEXT i
MittelW = Summe / 7

FOR i = 1 TO 7
 Abw(i) = ABS(Mess(i) - MittelW)  'Abweichung vom Mittelwert berechnen
NEXT i

Index1 = 1                        'wenn alles identisch, Messwert 1 loeschen
Max = 0
FOR i = 1 TO 7
 IF Abw(i) > Max THEN             'maximal Abweichung1 suchen
   Max = Abw(i)
   Index1 = i                     '... Stelle merken
 END IF
NEXT i
Summe = Summe - Mess(Index1)      'Abweichlerwert aus Summe entfernen
Mess(Index1) = 0                  '... und loeschen
MittelW = Summe / 6               'Mittelwert neu berechnen
Mess(Index1) = MittelW            'Abweichler durch neuen Mittelwert ersetzen

FOR i = 1 TO 7
 Abw(i) = ABS(Mess(i) - MittelW)  'Abweichung vom Mittelwert neu berechnen
NEXT i

Index2 = 2                        'wenn alles identisch, Messwert 2 loeschen
Max = 0
FOR i = 1 TO 7
 IF Abw(i) > Max THEN             'maximale Abweichung2 suchen
   Max = Abw(i)
   Index2 = i                      '... Stelle merken
 END IF
NEXT i
Summe = Summe - Mess(Index2)       'Abweichlerwert aus Summe entfernen


'Mess(Index2) = 0                  'loeschen
'Mess(Index1) = 0                  '
'FOR i = 1 TO 7
 'LOCATE 9: PRINT USING "    ### "; Mess(i);
'NEXT i

MittelW2 = Summe / 5

END FUNCTION

SUB Params (Titel$)

'Programmparameter abfragen

CALL TitelZeile

Lz:
LOCATE 5, 1
PRINT " Bitte Laufzeit in Min eingeben (X-Achse); mit [Enter] abschlieen"
PRINT SPACE$(80);
LOCATE , 1
LINE INPUT " > ", T$
IF T$ = "" THEN T$ = "1"
IF UCASE$(T$) = "E" THEN CALL EndBild
ASek& = VAL(T$)
IF ASek& < 1 OR ASek& > 527040 THEN GOTO Lz
LOCATE 6, 3
PRINT ASek&; SPACE$(78 - POS(0))
ASek& = ASek& * 60

MinWert:
LOCATE 8, 1
PRINT " Bitte MINIMALwert der Y-Achse (Messwerte) eingeben; mit [Enter] abschlieen"
PRINT SPACE$(80);
LOCATE , 1
LINE INPUT " > ", T$
IF T$ = "" THEN T$ = "-10"
IF UCASE$(T$) = "E" THEN CALL EndBild
IF UCASE$(T$) = "Z" THEN GOTO Lz
YMin! = XVal!(T$)
IF YMin! > 998 THEN GOTO MinWert
LOCATE 9, 3
PRINT YMin!; SPACE$(78 - POS(0))

MaxWert:
LOCATE 11, 1
PRINT " Bitte MAXIMALwert der Y-Achse (Messwerte) eingeben; mit [Enter] abschlieen"
PRINT SPACE$(80);
LOCATE , 1
LINE INPUT " > ", T$
IF T$ = "" THEN T$ = "40"
IF UCASE$(T$) = "E" THEN CALL EndBild
IF UCASE$(T$) = "Z" THEN GOTO MinWert
YMax! = XVal!(T$)
IF YMax! <= YMin! OR YMax! > 999 THEN GOTO MaxWert
LOCATE 12, 3
PRINT YMax!; SPACE$(78 - POS(0))

MessIntervall:
LOCATE 14, 1
PRINT " Bitte Aufzeichnungsintervall in Sekunden (max. 32767) eingeben; keine Eingabe"
PRINT " fr automatische Berechnung (max. 600 Messwerte); mit [Enter] abschlieen"
PRINT SPACE$(80);
LOCATE , 1
LINE INPUT " > ", T$
IF UCASE$(T$) = "E" THEN CALL EndBild
IF UCASE$(T$) = "Z" THEN GOTO MaxWert
MessInterv = VAL(T$)
LOCATE 16, 3
PRINT MessInterv; SPACE$(78 - POS(0))
IF MessInterv < 0 OR MessInterv > ASek& THEN GOTO MessIntervall
LOCATE 16, 4
IF MessInterv = 0 THEN PRINT "auto";

'Messintervall so dimensionieren, dass max 600 Messwerte
'aufgezeichnet werden (Auflsung)
IF MessInterv = 0 THEN MessInterv = (ASek& - 1) \ 600 + 1

Zeitbasis:
LOCATE 18, 1
PRINT " Zeitbasis (X-Achse) bestimmen: U fr Uhrzeit; andere Eingabe fr Laufzeit"
PRINT SPACE$(80);
LOCATE , 1
PRINT " > ";
ZBasis$ = UCASE$(INPUT$(1))
IF ZBasis$ = "E" THEN CALL EndBild
IF ZBasis$ = "Z" THEN GOTO MessIntervall
IF ZBasis$ = "U" THEN PRINT "Uhrzeit" ELSE PRINT "Laufzeit"

LOCATE 21, 1
PRINT " Bitte Titel der Messreihe eingeben; mit [Enter] abschlieen"
PRINT SPACE$(80);
LOCATE , 1
PRINT " > ";
LINE INPUT Titel$
IF UCASE$(Titel$) = "E" THEN CALL EndBild
IF UCASE$(Titel$) = "Z" THEN GOTO Zeitbasis
IF Titel$ = "" THEN Titel$ = " T-Log 1.3  * Grafischer Temperaturlogger * Public Domain * >>fst'05<<"


END SUB

SUB Port

' *** Adressen LPT 1 & 2 einlesen

DEF SEG = 0

LPT1 = PEEK(&H408) + 256 * PEEK(&H409)
LPT2 = PEEK(&H40A) + 256 * PEEK(&H40B)

IF LPT2 = 0 THEN DRg = LPT1
EXIT SUB


' *** Bildschirm fr die Port - Auswahl schreiben

PortTest:

LOCATE 6
PRINT " Bitte parallelen Port whlen :"
PRINT " -----------------------------"
PRINT

IF LPT1 THEN
  PRINT " LPT 1       (bei "; LPT1; " Dez / "; HEX$(LPT1); " Hex)";
  LOCATE 10, 66: PRINT "->  Taste [1]"
 ELSE
  PRINT " LPT 1      * steht nicht zur Verfgung *"
END IF

  PRINT " LPT 2       (bei "; LPT2; " Dez / "; HEX$(LPT2); " Hex)";
  LOCATE 11, 66: PRINT "->  Taste [2]"

LPTTaste:

Taste$ = UCASE$(INPUT$(1))

' *** berprfung, ob Anschlu vorhanden
 
SELECT CASE Taste$
CASE IS = CHR$(27)
  CALL EndBild
CASE IS = "E"
  CALL EndBild
CASE IS = "Z"
  EXIT SUB
CASE IS = "1"
  IF LPT1 <= 0 THEN GOTO LPTTaste
  DRg = LPT1
CASE IS = "2"
  DRg = LPT2
CASE ELSE
  GOTO LPTTaste
END SELECT

END SUB

SUB SchnellEnde (GrDat)

OUT DRg, 0               'Spannungsversorgung aus
CALL DatenLoesch(GrDat)  'Abfrage; Datendateien loeschen
CALL EndBild             'Abschlussbidschirm und Schluss Aus Ende

END SUB

SUB sek2zeit (Seku&, Zeit$, StuMin$, MinSek$)

'aus Sekunden -> Stunden:Minuten:Sekunden machen

Stunden& = Seku& \ 3600
RestSeku& = Seku& - Stunden& * 3600
Minuten = RestSeku& \ 60
RestSeku& = RestSeku& - Minuten * 60
Sekunden = RestSeku&

'String erzeugen
'fhrende Nullen und Doppelpunkt ergnzen
IF Stunden& > 9 THEN
  Zeit$ = RIGHT$(STR$(Stunden&), 2)
 ELSE
  Zeit$ = "0" + RIGHT$(STR$(Stunden&), 1)
END IF
 Zeit$ = Zeit$ + ":"
IF Minuten > 9 THEN
  Zeit$ = Zeit$ + RIGHT$(STR$(Minuten), 2)
 ELSE
  Zeit$ = Zeit$ + "0" + RIGHT$(STR$(Minuten), 1)
END IF
 Zeit$ = Zeit$ + ":"
IF Sekunden > 9 THEN
  Zeit$ = Zeit$ + RIGHT$(STR$(Sekunden), 2)
 ELSE
  Zeit$ = Zeit$ + "0" + RIGHT$(STR$(Sekunden), 1)

END IF

StuMin$ = LEFT$(Zeit$, 5)
MinSek$ = RIGHT$(Zeit$, 5)

END SUB

SUB TitelZeile

CLS
PRINT
COLOR 0, 7
PRINT "     T-Log 1.3  - Grafischer Temperaturlogger                         >>fst'05<<";
PRINT "     zurck = [z]                  Ende = [e]                                   ";
COLOR 7, 0

END SUB

FUNCTION Tmr&
'Sekunden seit Mitternacht ausgeben
' bei Rechnern mit Power-Management (Handy-Organizer) funktioniert
' bei lngerer Programm-Inaktivitt die Basic-eigene TIMER-Funktion
' nicht zuverlssig.

 DEF SEG = 0
  C = PEEK(&H46C)
  D& = PEEK(&H46D)
  E& = PEEK(&H46E)
  Tmp& = C + D& * 256 + E& * 65536
  Tmr& = Tmp& / 18.2065

END FUNCTION

SUB WarteAuf (TT)
'SUB wird mit "WarteAuf 0" initialisiert
'bei erneutem Aufruf wird gewartet, bis die bergebe Anzahl Timer-Ticks
'(max 255 zu je 0,055 Sek) seit "WarteAuf 0" vergangen ist.

STATIC Start
STATIC Uebertr
STATIC DMax

DEF SEG = 0

IF TT = 0 THEN                             '0=Kennzahl fr Initialisierung
 Start = PEEK(&H46C)
 Uebertr = PEEK(&H46D) + PEEK(&H46E)
 DMax = 255
 IF PEEK(&H46E) = 24 THEN DMax = 175       'ab 25:59:50 - 0:00:00 = 175 Tics
END IF

IF TT > 0 THEN
 DO
  IF (PEEK(&H46D) + PEEK(&H46E)) <> Uebertr THEN Start = Start - DMax
 LOOP UNTIL PEEK(&H46C) - Start > TT
END IF


END SUB

SUB WertInDatei (Einheit$)

STATIC Datum0$

IF ZBasis$ = "U" THEN
  PRINT #2, UhrZeit$; CHR$(9); LTRIM$(STR$(Wert!));
  IF DATE$ <> Datum0$ THEN
    PRINT #2, " ; "; Datum$
   ELSE
    PRINT #2,
  END IF
  Datum0$ = DATE$
 ELSE
  PRINT #2, LTRIM$(STR$(Seku&)); CHR$(9); LTRIM$(STR$(Wert!))
END IF

END SUB

FUNCTION XVal! (A$)
 'Dezimalkomma in Dezimalpunkt wandeln
 x = INSTR(A$, ",")
 IF x > 0 THEN MID$(A$, x, 1) = "."
 XVal = VAL(A$)
END FUNCTION

SUB Zeitmess (T1&)

STATIC TAlt&, Tage&    'Timerstand vom vorherigen Aufruf und
                       'Sekunden fuer vergangene Tage festhalten

TJetzt& = Tmr&         'aktuellen Timerstand holen
UhrZeit$ = TIME$       'aktuelle Uhrzeit holen

'Tageswechsel zu Mitternacht auswerten (24 Std = 86400 Sek)
IF TJetzt& < TAlt& THEN Tage& = Tage& + 86400

TAlt& = TJetzt&        'Timerstand vom vorherigen Aufruf

'Messzeit in Sekunden errechnen:
Seku& = TJetzt& - T1& + Tage&

END SUB

